/* clean up a program by unfolding all calls to procedures
  with only one clause */

/* JPG: 28.10.89 */



cleanup(catom(Init,_),Prog,Newprog) :-
	!,
	functor(Init,P,_),
	iterateCl([P],Prog,[P|_],Newprog,[]).
cleanup(Init,Prog,Newprog) :-
	functor(Init,P,_),
	iterateCl([P],Prog,[P|_],Newprog,[]).


iterateCl([],_,_,Prog,Prog) :-
	!.
iterateCl(Newps,Prog,Lps,Prog1,Prog2) :-
	unfoldProcs(Newps,Prog,Prog1,Prog3,Lps,New),
	iterateCl(New,Prog,Lps,Prog3,Prog2).
	

unfoldProcs([],_,P,P,_,_) :-
	!.
unfoldProcs([P|Ps],Prog,[Newproc|Newcls],Prs,Live,New) :-
	getproc(P,Prog,Proc),
	unfoldEachClause(Proc,Newproc,Prog,Live,New),
	!,
	unfoldProcs(Ps,Prog,Newcls,Prs,Live,New).

unfoldEachClause([],[],_,_,_).
unfoldEachClause([(H :- B)|Cls],[(H :- B1)|Cls1],Prog,Liveps,New) :-
	det_unfold(B,B1,Prog),
	!,
	addLivePs(B1,Liveps,New),
	unfoldEachClause(Cls,Cls1,Prog,Liveps,New).
unfoldEachClause([_|Cls],Cls1,Prog,Liveps,New) :-
	unfoldEachClause(Cls,Cls1,Prog,Liveps,New).

det_unfold((G,Gs),B1,Prog) :-
	!,
	det_unfold(G,G1,Prog),
	det_unfold(Gs,Gs1,Prog),
	joingoals(G1,Gs1,B1).
det_unfold(G,G,_) :-
	imported(G),
	!.
det_unfold(G,true,_) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	call(G).
det_unfold(G,G,_) :-
	sp_builtin(G),
	!.
det_unfold(G,G,_) :-
	evaluable(G),
	!.
det_unfold(G,R,Prog) :-
	functor(G,P,_),
	getproc(P,Prog,Cls),
	unfold1(G,Cls,R),
	!.
det_unfold(_,fail,_).

unfold1(G,[Clause],R) :-
	copyterm(Clause,(G :- R)),
	!.
unfold1(G,_,G).

addLivePs((G,Gs),Lps,New) :-
	!,
	addLivePs(G,Lps,New),
	addLivePs(Gs,Lps,New).
addLivePs(G,Lps,New) :-
	prolog_meta(G,_,G1,_),
	!,
	addLivePs(G1,Lps,New).
addLivePs(G,_,_) :-
	sp_builtin(G),
	!.
addLivePs(G,_,_) :-
	imported(G),
	!.
addLivePs(G,_,_) :-
	evaluable(G),
	!.
addLivePs(G,Lps,New) :-
	G =.. [P|_],
	add(P,Lps,New).

add(P,Lps,New) :-
	var(Lps),
	!,
	Lps = [P|_],
	memb1(P,New).
add(P,[P|_],_) :-
	!.
add(P,[_|Lps],New) :-
	add(P,Lps,New).

getproc(P,[[(H :- B)|Cls]|_],[(H :- B)|Cls]) :-
	functor(H,P,_),
	!.
getproc(P,[_|Prog],Proc) :-
	getproc(P,Prog,Proc).
getproc(_,[],[]).
	
