/* JPG: 1.9.91 */
/* determinate unfolding with user-controlled unfolding choices */

resultant(catom(G,C),Trace,R) :-
	constraints(C),
	ref_clause(G,B),
	derivation(B,R),
	arg(1,G,Trace).
	
/* Determinate unfolding only */

derivation(true,true) :-
	!.
derivation(Gs,Gs1) :-
	determinate_derivation_step(Gs,Gs2),
	!,
	derivation(Gs2,Gs1).
derivation(Gs,Gs).

determinate_derivation_step(Gs,Gs2) :-
	select_lit(Gs,B,Gs3,N),
	choices(B,Ch,Gs3),
	Ch=[(H :- R)],
	replace_goal(Gs,N,Gs2,H,R).

select_lit((G,Gs),G,Gs,1).
select_lit((B,Gs),G,(B,Gs1),N1) :-
	!,
	select_lit(Gs,G,Gs1,N),
	N1 is N+1.
select_lit(G,G,true,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((clause(G,B) :- true),
		[Gs]^
		(ref_clause(G,B),
		no_Deadend(B),
		no_Deadend(Gs)),
	Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	bagof((G :- true),[Gs]^(call(G),no_Deadend(Gs)), Ps).
choices(G,[(G :- true)],Gs) :-
	constraintgoal(G),
	!,
	{G},
	no_Deadend(Gs).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Cs,Gs) :-
	bagof((G :- B),
		[Gs]^
		(ref_clause(G,B),
		no_Deadend(B),
		no_Deadend(Gs)), 
	Cs).

constraintgoal(_ > _).
constraintgoal(_ < _).
constraintgoal(_ >= _).
constraintgoal(_ =< _).
constraintgoal(_ = _).
constraintgoal(_ =\= _).
