/* read in a program, for specialisation system */
/* use of this procedure avoids the need to 
   declare each predicate as dynamic */
/* This version also builds a dependency graph for the program */


sp_consult(F) :-
	newline,
	nofileerrors,
	see(library(F)),
	fileerrors,
	read(C),
	read_clauses(C),
	seen,
	newline,
	write('Finished reading '),write(F),
	newline,
	!.
sp_consult(F) :-
	name(F,FN),
	name('.pl',S),
	file_suffix(FN,S,FS),
	name(F1,FS),
	nofileerrors,
	see(library(F1)),
	fileerrors,
	read(C),
	read_clauses(C),
	seen,
	newline,
	write('Finished reading '),write(F1),
	newline,
	!.
sp_consult(F) :-
	newline,
	nofileerrors,
	see(F),
	fileerrors,
	read(C),
	read_clauses(C),
	seen,
	newline,
	write('Finished reading '),write(F),
	newline,
	!.
sp_consult(F) :-
	name(F,FN),
	name('.pl',S),
	file_suffix(FN,S,FS),
	name(F1,FS),
	nofileerrors,
	see(F1),
	fileerrors,
	read(C),
	read_clauses(C),
	seen,
	newline,
	write('Finished reading '),write(F1),
	newline,
	!.
sp_consult(F) :-
	write('Cannot find file '), write(F),
	write(', or problems while reading.'), newline,newline.

read_clauses(end_of_file) :- 
	!.
read_clauses(C) :- 
	write('.'),
	assert(C),
	build_graph(C),
	read(C1),
	!,
	read_clauses(C1).

file_suffix([],X,X).
file_suffix([X|Xs],Ys,[X|Zs]) :-
	file_suffix(Xs,Ys,Zs).

build_graph((H :- B)) :-
	!,
	functor(H,F,N),
	add_deps(F/N, B).
build_graph(_).

add_deps(_,true) :-
	!.
add_deps(P,(B,Bs)) :-
	!,
	add_dep(P,B),
	add_deps(P,Bs).
add_deps(P,B) :-
	add_dep(P,B).

add_dep(P,\+ B) :-
	!,
	functor(B,G,M),
	assert(depends(P,G/M)).
add_dep(P, B) :-
	functor(B,G,M),
	assert(depends(P,G/M)).
	
library_directory('/home/staff/john/Exs').
