ans_clauses(X) :- 
	end_of_file(X),
	!.
ans_clauses((A :- B)) :- 
	!,
	answerlits(B,Bs),
	canonical((ans(A) :- query(A),Bs)),
	joingoals(query(A),Bs,Bs1),
	displayqRClauses([(ans(A) :- Bs1)]),
	read(C1),
	!,
	ans_clauses(C1).
ans_clauses(A) :- 
	canonical((ans(A) :- query(A))),
	displayqRClauses([(ans(A) :- query(A))]),
	read(C1),
	!,
	ans_clauses(C1).

answerlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	answerlits(Bs,Bs1).
answerlits((B,Bs),(ans(B),Bs1)) :-
	!,
	answerlits(Bs,Bs1).
answerlits(B,B) :-
	sp_builtin(B).
answerlits(B,ans(B)).

magic(F,F1,Q) :-
	see(F),
	tell(F1),
	read(C),
	ans_clauses(C),
	seen,
	see(F),
	read(C1),
	query_clauses(C1),
	seen,
	canonical(Q),
	displayqRClauses([(query(Q) :- true)]),
	nl,
	told.


query_clauses(X) :- 
	end_of_file(X),
	!.
query_clauses((A :- B)) :- 
	!,
	bodylitqueries(A,B),
	read(C1),
	!,
	query_clauses(C1).
query_clauses(_) :- 
	read(C1),
	!,
	query_clauses(C1).

bodylitqueries(_,true) :-
	!.
bodylitqueries(A,B) :-
	removelast(B,Bj,Bs1),
	sp_builtin(Bj),
	!,
	bodylitqueries(A,Bs1).
bodylitqueries(A,B) :-
	removelast(B,Bj,Bs1),
	!,
	answerlits(Bs1,Bs2),
	canonical((query(Bj) :- query(A),Bs2)),
	joingoals(query(A),Bs2,Bs3),
	displayqRClauses([(query(Bj) :- Bs3)]),
	bodylitqueries(A,Bs1).

removelast((B,C,Bs),Bn,(B,Bs1)) :-
	!,
	removelast((C,Bs),Bn,Bs1).
removelast((B,C),C,B) :-
	!.
removelast(B,B,true).
	
