ans_clauses(X) :- 
	end_of_file(X),
	!.
ans_clauses((:- _)) :- 
	!,
	read(C1),
	!,
	ans_clauses(C1).
ans_clauses((A :- B)) :- 
	!,
	answerlits(B,Bs),
	flat_name('_ans'(A),AA),
	flat_name(query(A),QA),
	flat_names(Bs,FBs),
	canonical((AA :- QA,FBs)),
	displayqRClauses([(AA :- QA,FBs)]),
	read(C1),
	!,
	ans_clauses(C1).
ans_clauses(A) :- 
	flat_name('_ans'(A),AA),
        flat_name(query(A),QA),
        canonical((AA :- QA)),
        displayqRClauses([(AA :- QA)]),
	read(C1),
	!,
	ans_clauses(C1).

answerlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	answerlits(Bs,Bs1).
answerlits((B,Bs),('_ans'(B),Bs1)) :-
	!,
	answerlits(Bs,Bs1).
answerlits(B,B) :-
	sp_builtin(B).
answerlits(B,'_ans'(B)).

flat_name(A,A) :-
	sp_builtin(A),
	!.
flat_name(A,A1) :-
	A =.. [F,As],
	As =.. [G|Args],
	name(F,Fn),
	name(G,Gn),
	concat(Gn,[95|Fn],An),
	name(H,An),
	A1 =.. [H|Args].

flat_names((B,Bs),(B1,Bs1)) :-
	!,
	flat_name(B,B1),
	flat_names(Bs,Bs1).
flat_names(B,B1) :-
	flat_name(B,B1).

magic(F,F1,Q) :-
	tell(F1),
	query_answer_clauses(F,Q),
	told.

query_answer_clauses(F,Q) :-
	see(F),
	read(C),
	ans_clauses(C),
	seen,
	see(F),
	read(C1),
	query_clauses(C1),
	seen,
	flat_name(query(Q),QQ),
	canonical( QQ ),
	displayqRClauses([(QQ :- true)]),
	nl.


query_clauses(Z) :- 
	end_of_file(Z),
	!.
query_clauses((A :- B)) :- 
	!,
	bodylitqueries(A,B),
	read(C1),
	!,
	query_clauses(C1).
query_clauses(_) :- 
	read(C1),
	!,
	query_clauses(C1).

bodylitqueries(_,true) :-
	!.
bodylitqueries(A,B) :-
	removefirst(B,Bj,Bs1),
	sp_builtin(Bj),
	!,
	bodylitqueries(A,Bs1).
bodylitqueries(A,B) :-
	removefirst(B,Bj,Bs1),
	!,
	answerlits(Bs1,Bs2),
	flat_names(Bs2,QBs2),
	flat_name(query(Bj),QBj),
	flat_name(query(A),QA),
	canonical((QBj :- QA,QBs2)),
	displayqRClauses([(QBj :- QA,QBs2)]),
	bodylitqueries(A,Bs1).

removefirst((B,Bs),B,Bs) :-
	!.
removefirst(B,B,true) :-
	!.
	
concat([],Xs,Xs).
concat([X|Xs],Ys,[X|Zs]) :-
	concat(Xs,Ys,Zs).

