/* computes the determinate unfolding rule */
/* JPG: 10.7.90 */

%:- setdebug.

resultant(A,R) :-
        resultant(A,_,R).

resultant(G,G1,R) :-
	nonrecpred(G),
	!,
	copyterm(G,G1),
	canonical(G1),
	ref_clause(G,B,N),
	no_cut_Deadend(B),
	prefix(B,P1,R),
	my_append(P1,[N],P).
resultant(G,P,R) :-
	ref_clause(G,B,N),
	no_cut_Deadend(B),
	prefix(B,P1,R),
	my_append(P1,[N],P).
	%choicelist(R,Chs).
	

choicelist(G,[var]) :-
	var(G),
	!.
choicelist((G,Gs),[Ch|Chs]) :-
	!,
	choice(G,Ch),
	choicelist(Gs,Chs).
choicelist(G,[Ch]) :-
	choice(G,Ch).


prefix(true,[],true) :-
	!.
prefix(Gs,[(N,C)|Ns],Gs1) :-
	det_eval(Gs,Gs2,N,C),
	!,
	prefix(Gs2,Ns,Gs1).
prefix(Gs,[],Gs).

det_eval(Gs,Gs1,N,C) :-
	select_cut_lit(Gs,B,Gs3,N),
	choices(B,Ch,Gs3),
	Ch = [(C,(H :- R))], /* determinate */
	nocut_etc(R),
	!,
	replace_goal(Gs,N,Gs1,H,R).

nocut_etc(true).
nocut_etc((B,Bs)) :-
	!,
	functor(B,F,_),
	F \== '!',
	F \== '->',
	F \== ';',
	nocut_etc(Bs).
nocut_etc(B) :-
	!,
	functor(B,F,_),
	F \== '!',
	F \== '->',
	F \== ';'.


select_cut_lit((G,Gs),G,Gs,1).
select_cut_lit((B,Gs),G,(B,Gs1),N1) :-
        !,
	functor(B,F,_),
	F \== '!',
	F \== ';',
	F \== '->',
        select_cut_lit(Gs,G,Gs1,N),
        N1 is N+1.
select_cut_lit(G,G,true,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),[Gs]^(ref_clause(G,B,N),
		no_cut_Deadend(B)),Cs).
		%no_cut_Deadend(B),
		%no_cut_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G)), Ps).
	%bagof((P,(G :- true)),[Gs]^(call(G),no_cut_Deadend(Gs)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G)), Ps).
%	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_cut_Deadend(Gs)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
	[Gs]^(ref_clause(G,B,N),no_cut_Deadend(B)), Cs).
%	[Gs]^(ref_clause(G,B,N),no_cut_Deadend(B),no_cut_Deadend(Gs)), Cs).

no_cut_Deadend(B) :-
        bagof(B, (no_cut_Deadend1(B),!),_).

%no_cut_Deadend1(G) :-
%        var(G),
%        !.
no_cut_Deadend1(('!',_)) :-
	!.
no_cut_Deadend1((G,Gs)) :-
        !,
        no_cut_Deadend1(G),
        no_cut_Deadend1(Gs).
no_cut_Deadend1('!') :-
	!.
no_cut_Deadend1(G) :-
        imported(G),
        !.
no_cut_Deadend1(G) :-
        sp_builtin(G),
        unfoldable(G),
        !,
        call(G).
no_cut_Deadend1(G) :-
        sp_builtin(G),
        !.
no_cut_Deadend1(G) :-
        ub_clause(G,_).

cleanup(_,X,X).
