abint(catom(Atom,(U,C)),[Element|Pfg],Pathtable,K0,K2) :-
	canonical((Atom,U)),
        compute_path(catom(Atom,(U,C)),Pathtable,Path,K0,K1),
	Element = element(Path,[catom(Atom,(U,C))|_],_,_),
	iterate([(Path,catom(Atom,(U,C)))],_,[Element|Pfg],Pathtable,K1,K2).

/* procedure iterate computes a sequence of successively greater sets
   of calls and answers, terminating when two successive elements of the
   sequence are the same  */

iterate([],[],_,_,K,K) :-
	!,
	write('End of Analysis'),nl.
iterate(NewCalls,NewAns,Atomset,Pathtable,K0,K3) :-
	trace_write_t(NewCalls),
	topdown(NewCalls,Atomset,Pathtable,MoreCalls,MoreAns,K0,K1),
	trace_write_d(NewAns),
	bottomup(NewAns,Atomset,Pathtable,MoreCalls,MoreAns,K1,K2),
	iterate(MoreCalls,MoreAns,Atomset,Pathtable,K2,K3).

topdown([],_,_,_,_,K,K) :-
	!.
topdown([(Path,A)|As],Atomset,Pathtable,MoreCalls,MoreAns,K0,K3) :-
	get_path(A,Pathtable,Path,Rs,K0,K1),
	topdown_callans(Rs,Path,Pathtable,Atomset,MoreCalls,MoreAns,K1,K2),
	topdown(As,Atomset,Pathtable,MoreCalls,MoreAns,K2,K3).
	
bottomup([],_,_,_,_,K,K) :-
	!.
bottomup([PA|PAs],Atomset,Pathtable,MoreCalls,MoreAns,K0,K2) :-
	find_resultants(PA, Atomset, Rs),
%	set_openlistcopy(Rs,Rs1),
	bottomup_callans(Rs,PA,Pathtable,Atomset,MoreCalls,MoreAns,K0,K1),
	bottomup(PAs,Atomset,Pathtable,MoreCalls,MoreAns,K1,K2).

bottomup_callans(Vr,_,_,_,_,_,K,K) :-
	var(Vr),
        !.
bottomup_callans([res((HRU,UDefs),PH)|Rs],Pnew,Ptable,Atomset,MoreCalls,MoreAns,K0,K2) :-
	melt(HRU,((MH :- MR),MU)),
	newans_solve(MR,MH,MU,UDefs,Atomset,Ptable,res((HRU,UDefs),PH),Pnew,MoreCalls,MoreAns,K0,K1),
	bottomup_callans(Rs,Pnew,Ptable,Atomset,MoreCalls,MoreAns,K1,K2).

set_openlistcopy(X,_) :-
	var(X),
	!.
set_openlistcopy([X|L],L1) :- 
	insert_resultant(X,L1),
	set_openlistcopy(L,L1).


topdown_callans([],_,_,_,_,_,K,K) :-
	!.
topdown_callans([((H :- R,U),UDefs)|Rs],Path,Ptable,Atomset,MoreCalls,MoreAns,K0,K3) :-
	melt((H :- R,U),(MH :- MR,MU)),
	ans_solve(MR,MH,MU,UDefs,Atomset,Ptable,res((((H :- R),U),UDefs),Path),
					MoreCalls,MoreAns,K0,K1),
	topdown_callans(Rs,Path,Ptable,Atomset,MoreCalls,MoreAns,K1,K3).


ans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1) :-
	var(B),
	!,
	ans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1).
ans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1) :-
	imported(B),
	!,
	ans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1).
ans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1) :-
	sp_builtin(B),
	!,
	ans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1).
ans_solve((Bj,Bs),H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K2) :-
	constrained_atom(Bj,U,UDefs,[Call]),
	insert_call(Call,Atomset,Pathtable,R,CPath,MoreCalls,K0,K1),
	!,
	ans_solve1(Bs,CPath,Pathtable,Bj,H,U,UDefs,Atomset,R,
			MoreCalls,MoreAns,K1,K2).
ans_solve(Bj,H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1) :-
	nonvar(Bj),
	Bj =.. [F|_],
	F \== true,
	F \== ',',
	!,
	ans_solve((Bj,true),H,U,UDefs,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1).
ans_solve(Bj,H,U,UDefs,Atomset,_,res(_,Path),_,MoreAns,K0,K1):-
	var(Bj),
	!,
	constrained_atom(H,U,UDefs,[Ans]),
	insert_answer(Path,Ans,Atomset,MoreAns,K0,K1).
ans_solve(true,H,U,UDefs,Atomset,_,res(_,Path),_,MoreAns,K0,K1):-
	!,
	constrained_atom(H,U,UDefs,[Ans]),
	insert_answer(Path,Ans,Atomset,MoreAns,K0,K1).
ans_solve(_,_,_,_,_,_,_,_,_,K,K).


ans_solve1(Bs,CPath,Pathtable,B,H,U1,UDefs1,Atomset,R,MoreCalls,MoreAns,K0,K2) :-
	find_ans(CPath,B,Atomset,U2,UDefs2),
	joingoals(U2,U1,U3),
	app(UDefs2,UDefs1,UDefs3),
	soluble(U3,UDefs3,U4,S,K0,K1),
	app(S,UDefs3,UDefs4),
	!,
	ans_solve(Bs,H,U4,UDefs4,Atomset,Pathtable,R,MoreCalls,MoreAns,K1,K2).
ans_solve1(_,_,_,_,_,_,_,_,_,_,_,K,K).

/*
insert_call(Call,Atomset,Pathtable,R,CPath,MoreCalls,K0,K2) :-
        compute_path(Call,Pathtable,CPath,K0,K1),
        insert_atom(CPath,Call,Atomset,R,MoreCalls,K1,K2).

*/
insert_call(Call,Atomset,Pathtable,R,CPath,MoreCalls,K0,K3) :-
        compute_path(Call,Pathtable,CPath,K0,K1),
	last_atom(MoreCalls,_,0,N),
        insert_atom(CPath,Call,Atomset,R,MoreCalls,K1,K2),
	last_atom(MoreCalls,New,0,N1),
	reinsert_call(New,N,N1,Atomset,Pathtable,R,MoreCalls,K2,K3).

last_atom(MoreCalls,_,N,N) :-
	var(MoreCalls),
	!.
last_atom([C|MoreCalls],C,N,N1) :-
	var(MoreCalls),
	!,
	N1 is N+1.
last_atom([_|MoreCalls],C,N,N2) :-
	N1 is N+1,
	last_atom(MoreCalls,C,N1,N2).

reinsert_call(_,N,N,_,_,_,_,K,K) :-
	!.
reinsert_call((CPath,Call),N,N1,Atomset,Pathtable,R,MoreCalls,K0,K2) :-
	N1 is N+1,
        compute_path(Call,Pathtable,CPath,K0,K1),
        insert_atom(CPath,Call,Atomset,R,MoreCalls,K1,K2).

insert_answer(Path,A,[element(P1,_,As,_)|_],MoreAns,K0,K1) :-
        Path == P1,
        !,
        abstract_var(A,As,Path,MoreAns,K0,K1).
insert_answer(Path,A,[element(P1,_,_,_)|Atomset],MoreAns,K0,K1) :-
        Path \== P1,
        !,
        insert_answer(Path,A,Atomset,MoreAns,K0,K1).


newans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
        var(B),
        !,
        newans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1).
newans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
        imported(B),
        !,
        newans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1).
newans_solve((B,Bs),H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
        sp_builtin(B),
        !,
        newans_solve(Bs,H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1).
newans_solve((Bj,Bs),H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K2) :-
	constrained_atom(Bj,U,UDefs,[Call]),
        !,
        newans_solve1(Bs,Call,Pathtable,H,U,UDefs,Bj,Atomset,R,
                        Pnew,MoreCalls,MoreAns,K0,K2).
newans_solve(Bj,H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
        nonvar(Bj),
        Bj =.. [F|_],
        F \== true,
        F \== ',',
	!,
        newans_solve((Bj,true),H,U,UDefs,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1).
newans_solve(Bj,_,_,_,_,_,_,_,_,_,K,K):-
	var(Bj),
        !.
newans_solve(true,_,_,_,_,_,_,_,_,_,K,K):-
        !.
newans_solve(_,_,_,_,_,_,_,_,_,_,K,K).


newans_solve1(Bs,Call,Pathtable,H,U1,UDefs1,B,Atomset,R,Pnew,MoreCalls,MoreAns,K0,K2) :-
        find_path(Call,Pathtable,CPath),
        find_ans(CPath,B,Atomset,U2,UDefs2),
        joingoals(U2,U1,U3),
        app(UDefs2,UDefs1,UDefs3),
        soluble(U3,UDefs3,U4,S,K0,K1),
        app(S,UDefs3,UDefs4),
	!,
        newans_solve2(Bs,H,U4,UDefs4,Atomset,Pathtable,CPath,R,Pnew,MoreCalls,MoreAns,K1,K2).
newans_solve1(_,_,_,_,_,_,_,_,_,_,_,_,K,K).

% if the current call path is the new path (Pnew) then call ans_solve.

newans_solve2(Bs,H,U3,UDefs3,Atomset,Pathtable,Cpath,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
	Cpath == Pnew,
	!,
	ans_solve(Bs,H,U3,UDefs3,Atomset,Pathtable,R,MoreCalls,MoreAns,K0,K1).
newans_solve2(Bs,H,U3,UDefs3,Atomset,Pathtable,_,R,Pnew,MoreCalls,MoreAns,K0,K1) :-
	newans_solve(Bs,H,U3,UDefs3,Atomset,Pathtable,R,Pnew,MoreCalls,MoreAns,K0,K1).

	
find_ans(Path,B,[element(Path1,_,As,_)|_],MU,Defs) :-
	Path == Path1,
	!,
	nonvar(As),
	most_general(As,catom(A,(U,Defs))),
	melt((A,U),(B,MU)).
find_ans(Path,B,[_|Paths],U,Defs) :-
	find_ans(Path,B,Paths,U,Defs).

find_resultants(Path,[element(Path1,_,_,Rs)|_],Rs) :-
	Path == Path1,
	!.
find_resultants(Path,[_|Paths],Rs) :-
	find_resultants(Path,Paths,Rs).


/* Compute (or retrieve if already computed) the path of a given atom. */

compute_path(A,Pathtable,Path,K0,K1) :-
	get_path(A,Pathtable,Path,_,K0,K1).
	
/* The table of atoms and paths is stored as an ordered binary
   tree, with the atoms as keys.  */

get_path(A,Tree,Path,Atoms,K0,K1) :-
	var(Tree),
	!,
	unfold(A,Atoms,Path,K0,K1),
	Tree = tree(A,Path,Atoms,_,_).
get_path(A,tree(A1,Path,Atoms,_,_),Path,Atoms,K,K) :-
	rulatom_equal(A,A1),
	!.
get_path(A,tree(A1,_,_,Left,_),Path,Atoms,K0,K1) :-
	A @< A1,
	get_path(A,Left,Path,Atoms,K0,K1).
get_path(A,tree(A1,_,_,_,Right),Path,Atoms,K0,K1) :-
	A @> A1,
	get_path(A,Right,Path,Atoms,K0,K1).

/* find_path - like get_path but fails if the atoms is not found */

find_path(A,tree(A1,Path,_,_,_),Path) :-
	nonvar(A1),
	rulatom_equal(A,A1),
	!.
find_path(A,tree(A1,_,_,Left,_),Path) :-
	nonvar(A1),
	A @< A1,
	find_path(A,Left,Path).
find_path(A,tree(A1,_,_,_,Right),Path) :-
	nonvar(A1),
	A @> A1,
	find_path(A,Right,Path).

/* insert_atom(Path,A,Atomset,MoreCalls):  insert the atom A with Path
   into the Atomset.   Find the upper bound of A and the set of atoms in
   Atomset with the same Path.  If the result is not in Atomset, then
   insert it into Atomset and add it to the list MoreCalls. */

insert_atom(Path,A,Atomset,R,MoreCalls,K,K) :-
	var(Atomset),
	!,
%	Atomset = [element(Path,[A|_],_,[res(R,PH)|_])|_],
	Atomset = [element(Path,[A|_],_,[R|_])|_],
	rulatom_memb(Path,A,MoreCalls).
insert_atom(Path,A,[element(P1,As,_,Rs)|_],R,MoreCalls,K0,K1) :-
	Path == P1,
	!,
	abstract(A,As,MoreCalls,Path,K0,K1),
%	insert_resultant(res(R,PH),Rs).
	insert_resultant(R,Rs).
insert_atom(Path,A,[element(P1,_,_,_)|Atomset],R,MoreCalls,K0,K1) :-
	Path \== P1,
	!,
	insert_atom(Path,A,Atomset,R,MoreCalls,K0,K1).

abstract(A,[A1|As],MoreCalls,Path,K0,K1) :-
	var(As),
	!,
	lub(A,A1,A2,K0,K1),
	eliminate_true(A1,A11),
	eliminate_true(A2,A22),
	insert_it(A11,A22,As,Path,MoreCalls).
abstract(A,[_|As],MoreCalls,Path,K0,K1) :-
	abstract(A,As,MoreCalls,Path,K0,K1).

eliminate_true(catom(A,(U,Udefs)),catom(A,(U1,Udefs))) :-
	no_true_ending(U,U1).

no_true_ending((B,true),B) :-
	B \== true,
	!.
no_true_ending((B,Bs),(B,Bs1)) :-
	Bs \== true,
	!,
	no_true_ending(Bs,Bs1).
no_true_ending(B,B).  

abstract_var(A,As,Path,MoreAns,K,K) :-
	var(As),
	!,
	As = [A|_],
	memb1(Path,MoreAns).
%	MoreAns = [Path|_].

abstract_var(A,As,Path,MoreAns,K0,K1) :-
	abstract(A,As,Tmp,Path,K0,K1),
	insert_path(Tmp,Path,MoreAns).

insert_path(Tmp,_,_) :-
	var(Tmp),
	!.
insert_path(_,Path,MoreAns) :-
	memb1(Path,MoreAns).

insert_resultant(R,Rs) :-
	var(Rs),
	!,
	Rs = [R|_].
insert_resultant(res(((Cl,_),_),_),[res(((Cl1,_),_),_)|_]) :-
	Cl == Cl1,
	!.
insert_resultant(R,[_|Rs]) :-
	insert_resultant(R,Rs).

insert_it(A,A1,_,_,_) :-
	rulatom_equal(A,A1),
	!.
insert_it(_,A,[A|_],Path,MoreCalls) :-
	rulatom_memb(Path,A,MoreCalls).
	
rulatom_memb(P,A,MoreCalls) :-
	var(MoreCalls),
	!,
	MoreCalls = [(P,A)|_].
rulatom_memb(_,A,[A1|_]) :-
	rulatom_equal(A,A1),
	!.
rulatom_memb(P,A,[_|MoreCalls]) :-
	rulatom_memb(P,A,MoreCalls).
	
	
collect_atoms([],[],[],K,K) :-
	!.
collect_atoms([(Head,Path,(R,U,C))|Rs],[(Resultant, C)|Bs],[Path1|Ps],K0,K1) :-
	collect_atoms(Rs,Bs,Ps,K0,K1),
	copyterm((Head :- R,U),Resultant),
	canonical(Resultant),
	copyterm(Path,Path1),
	canonical(Path1).
	
collect_atoms_nopath([],[],K,K) :-
	!.
collect_atoms_nopath([(Head,(R,U,C))|Rs],[(Resultant, C)|Bs],K0,K1) :-
	collect_atoms_nopath(Rs,Bs,K0,K1),
	copyterm((Head :- R,U),Resultant),
	canonical(Resultant).
	
soluble(U,C,U2,C1,K0,K1) :-
	unfold_body(U,C,U1),
	intersect_body(U1,C,U2,C1,K0,K1).
	
constrained_atom(B,U,C,[catom(B2,(U2,BCs))]) :-
	copyterm((B,U),(B1,U1)),
	B1 =.. [P,_|T],
	B2 =.. [P,_|T],
        vars(B2,Vs),
	project_types(Vs,U1,U2),
	tempclause(U2,Vs,TCl),
	rdefs(temp,[proc(temp/1,[TCl])|BCs],[proc(temp/1,[TCl])|C]),
%	canonical((B2,U2)),
	!.

tempclause(U,Vs,(temp(H) :- U)) :-
%	copyterm((U,Vs),(U1,Vs1)),
	canonical(Vs),
	H =.. [temp|Vs].

tempheadvars(true,[]) :-
	!.
tempheadvars((B,Bs),[X|Xs]) :-
	!,
	B =.. [_,X],
	tempheadvars(Bs,Xs).
tempheadvars(B,[X]) :-
	B =.. [_,X].
	
project_types([],_,true) :-
	!.
project_types([X],U1,U) :-
	!,
	type_of(X,U1,U).
project_types([X|Xs],U1,(U,U2)) :-
	type_of(X,U1,U),
	project_types(Xs,U1,U2).

type_of(X,(B,_),B) :-
	B =.. [_,Y],
	X == Y,
	!.
type_of(X,(_,Bs),B) :-
	!,
	type_of(X,Bs,B).
type_of(X,B,B) :-
	B =.. [_,Y],
	X == Y,
	!.
type_of(X,_,any(X)).

unfold(catom(A,(U,C)),Atoms,P,K0,K1) :-
	var(P),
	!,				% path not yet known
	trace_atom(catom(A,(U,C))),
	melt((A,U),(Ma,MU)),
	bagof((Ma,Path,R), 
		MU^resultant(catom(Ma,(MU,C)),Path,R,K0),
		Rs),
	%findall((Ma,Path,R), 
	%	resultant(catom(Ma,(MU,C)),Path,R,K0),
	%	Rs),
	collect_atoms(Rs,Atoms,P,K0,K1).
unfold(catom(A,(U,C)),Atoms,P,K0,K1) :-
	trace_atom(catom(A,(U,C))),
	write('Unfold using trace-term'),nl,
	melt((A,U),(Ma,MU)),
	bagof((Ma,R), 
		(MU,Path)^(memb2(Path,P),
		    resultant(catom(Ma,(MU,C)),Path,R,K0)),
		Rs),
	%findall((Ma,R), 
	%	resultant(catom(Ma,(MU,C)),Path,R,K0),
	%	Rs),
	collect_atoms_nopath(Rs,Atoms,K0,K1).


:- dynamic trace_on/0.
:- dynamic atom_trace/0.

/* trace_on. */

trace_atom(X) :-
	atom_trace,
	!,
	nl,write(X),sp_ttyflush.
trace_atom(_) :-
	write('.'),
	sp_ttyflush.

/*
trace_write(X) :-
	trace_on,
	!,
	nl,write(X),nl.
trace_write(_) :-
	write('*'),sp_ttyflush.
*/


trace_write_t(_) :-
	write('t '),
	sp_ttyflush.
trace_write_d(_) :-
	write('d '),
	sp_ttyflush.
