/* time(G):  Gives time to run goal G */

time(G) :-
	statistics(runtime,[_,_]),
	call(G),
	statistics(runtime,[_,T4]),
	T is T4/1000,
	nl,
	write('Time: '),
	write(T),nl .
	
space(G) :-
	statistics(runtime,[_,_]),
	call(G),
	statistics(runtime,[_,T4]),
	statistics(global_stack,[GS,_]),
	statistics(trail,[Trail,_]),
	statistics(garbage_collection,[GCs,_,_]),
	T is T4/1000,
	nl,
	write('Time: '), write(T),nl,
	write('Global stack: '), write(GS),nl,
	write('Trail: '), write(Trail),nl,
	write('No. of GCs: '), write(GCs),nl .
	
/* test(G,N) : run goal G N times, and prints runtime  */



test(G,N) :- 
	time(run(G,0,N),Tp),
	time(run(true,0,N),Td),
	Rtp is Tp - Td,
	write(time(Rtp)).

time(G,T) :-
	statistics(runtime,_),
	call(G),
	statistics(runtime,[_,T1]),
	T is T1/1000.0 .

run(G,R,N) :- R < N, call(G), fail .
run(G,R,N) :- R < N, !, Rp1 is R + 1, run(G,Rp1,N) .
run(_,_,_) .

