vars(X,Vs) :-
        variable(X),
        insertvar(X,Vs).
vars(X,_) :-
        constant(X).
vars(X,Vs) :-
        term(X,_,Args),
        argvars(Args,Vs).

argvars([],_).
argvars([X|Xs],Vs) :-
        vars(X,Vs),
        argvars(Xs,Vs).

insertvar(X,[X|_]).
insertvar(X,[Y|Vs]) :-
	\+ (X = Y),
        insertvar(X,Vs).


variable(var(_)).
constant(X) :- atomic(X).
term(X,F,Args) :-
	\+ constant(X),
	\+ variable(X),
	nonvar(X),
	X =.. [F|Args].
